#import "AppDelegate.h"

@implementation AppDelegate

@synthesize records = _records;

- (void)applicationDidFinishLaunching:(NSNotification*)notification
{
	NSString *path = [[NSBundle mainBundle] pathForResource:@"xmlExample" ofType:@"xml"];
	NSData *xmlData = [NSData dataWithContentsOfFile:path];
	xmlTextReaderPtr reader = xmlReaderForMemory([xmlData bytes], 
																							 [xmlData length], 
																							 [path UTF8String], nil, 
		(XML_PARSE_NOBLANKS | XML_PARSE_NOCDATA | XML_PARSE_NOERROR | XML_PARSE_NOWARNING));
	if (!reader) {
		NSLog(@"Failed to load xmlreader");
		return;
	}
	NSString *currentTagName = nil;
	NSDictionary *currentPerson = nil;
	NSString *currentTagValue = nil;
	NSMutableArray *people = [NSMutableArray array];
	char* temp;
	while (true) {
		if (!xmlTextReaderRead(reader)) break;
		switch (xmlTextReaderNodeType(reader)) {
			case XML_READER_TYPE_ELEMENT:
				//We are starting an element
				temp =  (char*)xmlTextReaderConstName(reader);
				currentTagName = [NSString stringWithCString:temp 
																						encoding:NSUTF8StringEncoding];
				if ([currentTagName isEqualToString:@"person"]) {
					currentPerson = [NSMutableDictionary dictionary];
					[people addObject:currentPerson];
				}	
				continue;
			case XML_READER_TYPE_TEXT:
				//The current tag has a text value, stick it into the current person
				temp = (char*)xmlTextReaderConstValue(reader);
				currentTagValue = [NSString stringWithCString:temp 
																						 encoding:NSUTF8StringEncoding];
				if (!currentPerson) return;
				[currentPerson setValue:currentTagValue forKey:currentTagName];
				currentTagValue = nil;
				currentTagName = nil;
			default: continue;
		}
	}
	NSLog(@"%@:%s Final data: %@", [self class], _cmd, people);
	[self setRecords:people];
}

@end
